#include <stdlib.h>
#include "fxlib.h"

#include "collisions.h"
#include "struc.h"

void collisions_doodle(Doodle* doodle, Plate* listePlates)
{
	int j;
	Plate *tmp;

	j = doodle->saut.origine + doodle->saut.hauteur;
	tmp = listePlates;

    while(tmp)// Tant que l'on n'est pas au bout de la liste
    {

		if(doodle->saut.position > 0)// si on est dans la seconde partie du saut (on descend)
		{
			if(tmp->ressort == 1)
			{
				if ((j == tmp->x +HAUTEUR_PLATEFORME && doodle->y+8 > tmp->y && doodle->y < tmp->y + 4)  )//col avec ressort
				{
					doodle->saut.origine = j+1;
					doodle->saut.position = -51;
					doodle->saut.modeSaut = RESSORT;
					return;
				}
				if ((j == tmp->x +HAUTEUR_PLATEFORME-1 && doodle->y+8 > tmp->y && doodle->y < tmp->y + 4)   )
				{
					doodle->saut.origine = j+2;
					doodle->saut.position = -51;
					doodle->saut.modeSaut = RESSORT;
					return;
				}
			}
			else if(tmp->ressort == 2)
			{
				if ((j == tmp->x +HAUTEUR_PLATEFORME && doodle->y+1 > tmp->y && doodle->y < tmp->y + LARGEUR_PLATEFORME-1) )//col avec ressort
				{
					doodle->saut.origine = j+1;
					doodle->saut.position = -51;
					doodle->saut.modeSaut = RESSORT;
					return;
				}
				if ((j == tmp->x +HAUTEUR_PLATEFORME-1 && doodle->y+1 > tmp->y && doodle->y < tmp->y + LARGEUR_PLATEFORME-1) )
				{
					doodle->saut.origine = j+2;
					doodle->saut.position = -51;
					doodle->saut.modeSaut = RESSORT;
					return;
				}
			}
			/*collisions plateformes normales*/
			if ((j == tmp->x +HAUTEUR_PLATEFORME && doodle->y+9 > tmp->y && doodle->y < tmp->y + LARGEUR_PLATEFORME))
			{
				doodle->saut.origine = j+1;
				doodle->saut.position = -51;
				doodle->saut.modeSaut = NORMAL;
				if(tmp->mode == PONCTUELLE)// si on repondit une ponctuelle
					tmp->x = -10;// on met la plateforme en dessous de la camera pour qu'alle soit supprimee
				return;
			}
			if ((j == tmp->x +HAUTEUR_PLATEFORME -1&& doodle->y+9 > tmp->y && doodle->y < tmp->y + LARGEUR_PLATEFORME)  )
			{
				doodle->saut.origine = j+2;
				doodle->saut.position = -51;
				doodle->saut.modeSaut = NORMAL;
				if(tmp->mode == PONCTUELLE)// si on repondit une ponctuelle
					tmp->x = -10;// on met la plateforme en dessous de la camera pour qu'alle soit supprimee
				return;
			}
		}


		if(tmp->mode == JETPACK && j+13 >= tmp->x && j < tmp->x + 7  && doodle->y+5 >= tmp->y  && doodle->y < tmp->y + 11)
		{
			doodle->saut.modeSaut = JET;
			doodle->saut.origine = j + 1;
			doodle->saut.position = -151;
			tmp->mode = NORMALE;
		}
        tmp = tmp->nxt;
    }


}

