#include <stdlib.h>
#include "fxlib.h"

#include "gameover.h"
#include "fonctions.h"
#include "struc.h"
#include "gray.h"


int pause(int score)
{
	unsigned short pause[] = {57344, 65408, 8176, 1648, 1584, 1584, 1584, 1584, 1840, 1008, 480, 28672, 64000, 51968, 51584, 18816, 63872, 65408, 3840, 0,28672,65408,
	53120, 49152, 49152, 24576, 61440, 65408, 3968, 0, 24576, 59136, 53120, 52608, 56704, 63872, 29568, 768, 0, 15872, 32512, 60800, 52608, 52608, 52608, 28544, 12032};
	unsigned char scoreImg[] = {64, 206, 159, 153, 249, 115, 2, 120,
							248, 132, 204, 76, 0, 112, 248, 140,
							196, 124, 56, 0, 224, 252, 28, 8, 4,
							112, 252, 164, 188, 56, 0, 0, 0, 0,
							192, 204, 12};
	Screen* screen;
	screen = gray_getScreen();
	gray_clearVRAM();
	ML_bmp_or_buffer((unsigned char*)pause, 95, 8, 12, 47, screen->VRAM1);//en or_cl normalement
	ML_bmp_or_buffer((unsigned char*)pause, 95, 8, 12, 47, screen->VRAM2);
	ML_bmp_or_buffer(scoreImg, 65, 13, 8, 37, screen->VRAM1);
	ML_bmp_or_buffer(scoreImg, 65, 13, 8, 37, screen->VRAM2);

	afficher_nombres_buffer(score, 55, 20, screen->VRAM1);
	afficher_nombres_buffer(score, 55, 20, screen->VRAM2);
	gray_swapBuffers();
	gray_clearVRAM();

	while(IsKeyDown(KEY_CTRL_MENU));// on arrete d'appuyer sur MENU

	while( !IsKeyDown(KEY_CTRL_EXE) && !IsKeyDown(KEY_CTRL_MENU))
	{
		if(IsKeyDown(KEY_CTRL_EXIT))
			return 1;
		///Sleep(50);// on economise les piles
	}
	while(IsKeyDown(KEY_CTRL_MENU));
	while(IsKeyDown(KEY_CTRL_EXE));
	return 0;
}

void afficherGameOver(int x, int y, int score, int posCamera, Plate* listePlates)
{
	int i,j;
	unsigned char ligne = 126;
	unsigned short centreVRAM1[] = { 15360, 63520, 14384, 63504, 14352, 63504, 14384, 63520, 15360 };
	unsigned short centreVRAM2[] = { 16256, 61408, 12272, 61424, 12272, 61424, 12272, 61408, 16256 };
	unsigned char  droiteVRAM1[] = {120, 8, 0, 0, 0, 32, 0, 32, 8, 144, 144, 96, 144};
	unsigned char  droiteVRAM2[] = {120, 8, 0, 0, 0, 32, 0, 32, 8, 240, 240, 96, 144};
	Screen* screen;
	x = x - posCamera;
	screen = gray_getScreen();

	ML_bmp_or_cl_buffer((unsigned char*)centreVRAM1, x, y, 12, 9, screen->VRAM1);
	ML_bmp_or_cl_buffer((unsigned char*)centreVRAM2, x, y, 12, 9, screen->VRAM2);
	ML_bmp_or_cl_buffer(droiteVRAM1, x+5, y, 5, 13, screen->VRAM1);
	ML_bmp_or_cl_buffer(droiteVRAM2, x+5, y, 5, 13, screen->VRAM2);


/*
	afficher_plateformes(listePlates, posCamera);
	afficher_plateformes(listePlates, posCamera);*/

	for(i=-1; i<9; i++)// afficher les lignes
	{
		ML_bmp_or_cl_buffer(&ligne, (posCamera%16) + i*16,  0, 8, 1, screen->VRAM1);
		ML_bmp_or_cl_buffer(&ligne, (posCamera%16) + i*16,  0, 8, 1, screen->VRAM2);
		ML_bmp_or_cl_buffer(&ligne, (posCamera%16) + i*16, 63, 8, 1, screen->VRAM1);
		ML_bmp_or_cl_buffer(&ligne, (posCamera%16) + i*16, 63, 8, 1, screen->VRAM2);
	}

	gray_swapBuffers();
	gray_clearVRAM();
}


void game_over(int score, int x, int y, int posCamera, Plate* listePlates)
{
	int cameraOriginal;
	cameraOriginal = posCamera;


	gray_clearVRAM();
	while(posCamera > cameraOriginal - 200)
	{
		Sleep(5);
		afficherGameOver(x, y, score, posCamera, listePlates);
		posCamera -= 2 ;
		x -=1;
		if(y<49)// on ramene le doodle a droite
			y ++;
		else if(y>49)// on ramene le doodle a droite
			y --;

	}
	while(x > posCamera)
	{
		Sleep(5);
		afficherGameOver(x, y, score, posCamera, listePlates);
		x --;

	}
}

