#include <stdlib.h>
#include "fxlib.h"

#include "menu.h"
#include "fonctions.h"
#include "gray.h"



void touches(int* left, int* right, int tabScores[])
{
	int posMenu = 1, upLeft = 0, upRight = 0, keyNew=0, exeUp = 0, i;
	char chLeft[10] = "", chRight[10] = "";
	unsigned char gauche[] = { 124, 130, 130, 146, 116, 0, 200, 168, 168, 248, 0, 120, 128, 128, 248, 0, 112,
								136, 136, 80, 0, 254, 8, 8, 240, 0, 112, 168, 168, 176, 0, 0, 0, 0, 0, 136 };
	unsigned char droite[] = { 254, 130, 130, 68, 56, 0, 0, 248, 8, 0, 112, 136, 136, 112, 0, 0, 250, 0, 8, 254, 136, 0, 112, 168, 168, 176, 0, 0, 0, 0, 0, 136 };
	Screen* screen;
	screen = gray_getScreen();

	trouverTouches(*left, chLeft);
	trouverTouches(*right, chRight);
	while(IsKeyDown(KEY_CTRL_EXE));
	for(posMenu=1; posMenu > -1; posMenu--)
	{
		keyNew =0;
		gray_clearVRAM();
		ML_bmp_or_buffer(gauche, 100, 10, 7, 36, screen->VRAM1);
		ML_bmp_or_buffer(gauche, 100, 10, 7, 36, screen->VRAM2);
		ML_bmp_or_buffer(droite, 60, 10, 7, 32, screen->VRAM1);
		ML_bmp_or_buffer(droite, 60, 10, 7, 32, screen->VRAM2);
		ML_rectangle_buffer(58+posMenu*40, 8, 68+posMenu*40, 48, 1, BLACK, TRANSPARENT, screen->VRAM1);
		ML_rectangle_buffer(58+posMenu*40, 8, 68+posMenu*40, 48, 1, BLACK, TRANSPARENT, screen->VRAM2);
		afficher_chaine(chLeft, 90, 10, screen->VRAM1);
		afficher_chaine(chLeft, 90, 10, screen->VRAM2);
		afficher_chaine(chRight, 50, 10, screen->VRAM1);
		afficher_chaine(chRight, 50, 10, screen->VRAM2);

		gray_swapBuffers();

		while( !keyNew)// tant qu'aucune touche n'est pressee
		{
			for(i=14; i<=30046; i++)
			{
				if(IsKeyDown(i))// si une touche est activee
				{
					keyNew = i;

					if(keyNew != KEY_CTRL_MENU && keyNew != KEY_CTRL_EXIT && keyNew != KEY_CTRL_F5 && keyNew != KEY_CTRL_F6)
					{
						if(posMenu == 1)
						{
							*left = keyNew;
							trouverTouches(keyNew, chLeft);
						}
						else if(keyNew != *left)//si la touche de droite est differente de la touche gauche
						{
							*right = keyNew;
							trouverTouches(keyNew, chRight);
						}
						else// sinon, on annule
							posMenu = 0;
					}
					while(IsKeyDown(keyNew));
				}
				if(i== 187)i=30000;//on fait une boucle for avec i qui varie de 14 à 187 et de 30001 a 30046
			}
		}
	}

	gray_clearVRAM();
	ML_bmp_or_buffer(gauche, 100, 10, 7, 36, screen->VRAM1);
	ML_bmp_or_buffer(gauche, 100, 10, 7, 36, screen->VRAM2);
	ML_bmp_or_buffer(droite, 60, 10, 7, 32, screen->VRAM1);
	ML_bmp_or_buffer(droite, 60, 10, 7, 32, screen->VRAM2);
	afficher_chaine(chLeft, 90, 10, screen->VRAM1);
	afficher_chaine(chLeft, 90, 10, screen->VRAM2);
	afficher_chaine(chRight, 50, 10, screen->VRAM1);
	afficher_chaine(chRight, 50, 10, screen->VRAM2);

	gray_swapBuffers();

	//write_save_keys(*left, *right, tabScores);

	Sleep(1200);
	return;
}

void menu_score(int tabScores[])
{
	int i, x=100;
	Screen* screen;
	screen = gray_getScreen();

	gray_clearVRAM();
	afficher_chaine("RECORDS", 120, 14, screen->VRAM1);
	afficher_chaine("RECORDS", 120, 14, screen->VRAM2);
	for(i=1; i<11; i++)
	{
		afficher_nombres_buffer(i, x, 10-(i/10*5), screen->VRAM1);
		afficher_nombres_buffer(i, x, 10-(i/10*5), screen->VRAM2);
		ML_pixel_buffer(x+1, 16, BLACK, screen->VRAM1);
		ML_pixel_buffer(x+1, 16, BLACK, screen->VRAM2);
		ML_pixel_buffer(x+3, 16, BLACK, screen->VRAM1);
		ML_pixel_buffer(x+3, 16, BLACK, screen->VRAM2);
		if(tabScores[i-1]>0)
		{
			afficher_nombres_buffer(tabScores[i-1], x, 22, screen->VRAM1);
			afficher_nombres_buffer(tabScores[i-1], x, 22, screen->VRAM2);
		}
		x -= 8;
	}

	gray_swapBuffers();
	while(IsKeyDown(KEY_CTRL_EXE));
	while(IsKeyDown(KEY_CTRL_EXE) == 0);
	while(IsKeyDown(KEY_CTRL_EXE));

}

int trouverTouches(int key, char* chaine)
{
	switch (key)
	{
		case KEY_CTRL_F1:
			strcpy(chaine, "F1");
			break;
		case KEY_CTRL_F2:
			strcpy(chaine, "F2");
			break;
		case KEY_CTRL_F3:
			strcpy(chaine, "F3");
			break;
		case KEY_CTRL_F4:
			strcpy(chaine, "F4");
			break;
		case KEY_CTRL_F5:
			strcpy(chaine, "F5");
			break;
		case KEY_CTRL_F6:
			strcpy(chaine, "F6");
			break;

		case KEY_CTRL_SHIFT:
			strcpy(chaine, "SHIFT");
			break;
		case KEY_CTRL_OPTN:
			strcpy(chaine, "OPTN");
			break;
		case KEY_CTRL_VARS:
			strcpy(chaine, "VARS");
			break;
		case KEY_CTRL_MENU:
			strcpy(chaine, "MENU");
			break;
		case KEY_CTRL_LEFT:
			strcpy(chaine, "LEFT");
			break;
		case KEY_CTRL_UP:
			strcpy(chaine, "UP");
			break;

		case KEY_CTRL_ALPHA:
			strcpy(chaine, "ALPHA");
			break;
		case KEY_CHAR_SQUARE:
			strcpy(chaine, "SQR");
			break;
		case KEY_CHAR_POW:
			strcpy(chaine, "EXPO");
			break;
		case KEY_CTRL_EXIT:
			strcpy(chaine, "EXIT");
			break;
		case KEY_CTRL_DOWN:
			strcpy(chaine, "DOWN");
			break;
		case KEY_CTRL_RIGHT:
			strcpy(chaine, "RIGHT");
			break;

		case KEY_CTRL_XTT:
			strcpy(chaine, "X");
			break;
		case KEY_CHAR_LOG:
			strcpy(chaine, "LOG");
			break;
		case KEY_CHAR_LN:
			strcpy(chaine, "LN");
			break;
		case KEY_CHAR_SIN:
			strcpy(chaine, "SIN");
			break;
		case KEY_CHAR_COS:
			strcpy(chaine, "COS");
			break;
		case KEY_CHAR_TAN:
			strcpy(chaine, "TAN");
			break;

		case KEY_CHAR_FRAC:
			strcpy(chaine, "FRAC");
			break;
		case KEY_CTRL_FD:
			strcpy(chaine, "FD");
			break;
		case KEY_CHAR_LPAR:
			strcpy(chaine, "PAR GAUCHE");
			break;
		case KEY_CHAR_RPAR:
			strcpy(chaine, "PAR DROITE");
			break;
		case KEY_CHAR_COMMA:
			strcpy(chaine, "COMMA");
			break;
		case KEY_CHAR_STORE:
			strcpy(chaine, "STORE");
			break;

		case KEY_CHAR_0:
			strcpy(chaine, "0");
			break;
		case KEY_CHAR_DP:
			strcpy(chaine, "POINT");
			break;
		case KEY_CHAR_EXP:
			strcpy(chaine, "X10");
			break;
		case KEY_CHAR_PMINUS:
			strcpy(chaine, "NEG");
			break;
		case KEY_CTRL_EXE:
			strcpy(chaine, "EXE");
			break;

		case KEY_CHAR_1:
			strcpy(chaine, "1");
			break;
		case KEY_CHAR_2:
			strcpy(chaine, "2");
			break;
		case KEY_CHAR_3:
			strcpy(chaine, "3");
			break;
		case KEY_CHAR_PLUS:
			strcpy(chaine, "PLUS");
			break;
		case KEY_CHAR_MINUS:
			strcpy(chaine, "MOINS");
			break;

		case KEY_CHAR_4:
			strcpy(chaine, "4");
			break;
		case KEY_CHAR_5:
			strcpy(chaine, "5");
			break;
		case KEY_CHAR_6:
			strcpy(chaine, "6");
			break;
		case KEY_CHAR_MULT:
			strcpy(chaine, "MULT");
			break;
		case KEY_CHAR_DIV:
			strcpy(chaine, "DIV");
			break;

		case KEY_CHAR_7:
			strcpy(chaine, "7");
			break;
		case KEY_CHAR_8:
			strcpy(chaine, "8");
			break;
		case KEY_CHAR_9:
			strcpy(chaine, "9");
			break;
		case KEY_CTRL_DEL:
			strcpy(chaine, "DEL");
			break;
		case KEY_CTRL_AC:
			strcpy(chaine, "AC");
			break;
		default:
			return 0;
	}
	return 1;
}

