#ifndef _STRUC
#define _STRUC

#define LARGEUR_PLATEFORME 12
#define HAUTEUR_PLATEFORME 4

typedef enum {TRANSPARENT=-1, WHITE, BLACK, XOR, CHECKER} ML_Color;
typedef enum {GAUCHE,  DROITE} Direction;
typedef enum {NORMAL, RESSORT, JET} Mode_Saut;
typedef enum {NORMALE, PONCTUELLE, VIRTUELLE, JETPACK, HELICO, TEMPORISEE} Mode_Plate;

/*
typedef struct
{
	int hauteur;
	//int hauteurReelle;
	int type;
} Mob;
*/

typedef struct
{
	int position;
	int hauteur;
	int origine;
	Mode_Saut modeSaut;
} Saut;

typedef struct
{
	int x;
	int y;
	int posCamera;
	int score;
	int level;
	int bouclier;
	Direction dernierAppui;// Droite ou gauche
	Saut saut;
} Doodle;

typedef struct
{
	int* tab;
	int taille;
} Tab;

typedef struct
{
	int x;
	int nbRestants;
} Tempo;

typedef struct
{
	Tab jetPacks;
	Tab helicos;
	Tempo platesTempo;
	int var;
	//Mob mob;
} Autres;


typedef struct Plate Plate;
struct Plate
{
	double doubleY;
	double vecteur;
    int x;
	int y;
	int ressort;
	int tempo;
	int positionTempo;
	int temp;
	unsigned char pixelsTempo[48];
	Mode_Plate mode;
    Plate* nxt;
};

#endif
